/// bookmarklet for History.js // https://raw.github.com/gist/919358/bookmark-helper.js
(function(window,undefined){
	
	// Load Helpers
	var
		intervalScript, intervalJquery,
		loadScript = function(scriptUrl){
			var e = document.createElement('script');
			e.setAttribute('src',scriptUrl);
			window.document.body.appendChild(e);
			return e;
		};
	
	// Load In Basic Dependencies
	if ( typeof window.jQuery === 'undefined' || /^1\.[0-3]/.test(window.jQuery.fn.jquery) ) {
		loadScript('https://ajax.googleapis.com/ajax/libs/jquery/1.6.4/jquery.min.js');
	}

	// Load In Advanced Dependencies
	intervalJquery = setInterval(function(){
		if ( typeof window.jQuery !== 'undefined' ) {
			clearInterval(intervalJquery);
			loadScript('http://balupton.github.com/history.js/scripts/bundled/html4+html5/jquery.history.js');
			loadScript('https://raw.github.com/balupton/jquery-scrollto/master/scripts/jquery.scrollto.min.js');
		}
	},500);
	
	// Load In Script
	intervalScript = setInterval(function(){
		if ( typeof window.jQuery !== 'undefined' && typeof window.History !== 'undefined' && typeof window.History.initHtml4 !== 'undefined' ) {
			if ( window.console ) {
				window.console.log('Loading in script');
			}
			$(loadScript('https://raw.github.com/gist/854622/ajaxify-html5.js')).bind('load',function(){
				if ( typeof window.historyjsitNoAlert === 'undefined' ) {
					alert('History.js It! Is ready for action!');
				}
			});
			clearInterval(intervalScript);
		}
		else if ( window.console ) {
			window.console.log('Waiting for dependencies to load');
		}
	},500);
	
})(window);