/*
CARBON CYCLE CONTROLLER
author: stephen@hartzog.org

variables beginning with "$" are jquery objects (but not all are so labelled)
*/

var $nav;
//// Sound Variables
var $soundsdiv;
var $sndsnow = null;
var $sndslast = null;
var cplaying = null; /// currently playing sound

var $sndtransdiv;
var $sndstatediv;
var $sndeventdiv; /// mouseover sounds

var cstatesnd = [];

var sndbtn;

//var playlist = [];
//var $sndwrapper;
var sndflag = true; /// turn on/off sounds
// var gsndvol = 50; /// global volume control?

//// Text Variables
var $txt1, $txt2;
//// Image Variables
var $imgdiv1, $imgdiv2, $img1, $img2;

//// Div variables
var $area1, $area2;

var $mfollow; /// follows mouse; shows poetic text

/// used for transition;
var $lastcontent;

var cclass; /// used to pick option 1 or option 2; gets used in oncontentready, also, but very badly

/// current page url without all of the domain stuff
var curl;


var ishome = true; /// probably not the best way ...
var washome = false; // am i leaving the map?
var goinghome = false; // am i going home?

//var youaretxt;

/*$(window).bind('load', function() {
   // do the animation
});*/

var bgimg;
var bgimgdiv;


function init(){
	$nav = $('#nav');
	//$sndwrapper = $();
	/// grab the sound containers
	$soundsdiv = $('#snds');
	$sndtransdiv = $soundsdiv.find('#snd-list')
	$sndstatediv = $soundsdiv.find('#snd-state')
	$sndeventdiv = $soundsdiv.find('#snd-hover')

	$lastcontent = $('#lastcontent');
	//console.debug( ['INIT $lastcontent',$lastcontent] )
		
	sndbtn = $('<div style="background-color:#dddddd; cursor:pointer; font-size:10px;padding: 4px;" />').text('ON').appendTo( $soundsdiv.find('#snd-btn') ).on("click", function(event){
		sndtoggle();
	});
	
/* /// TOGGLE fx
	var tt = $('<div><button>Toggle fx</button></div>').on("click", function(event){
		$.fx.off = !$.fx.off;
	}).appendTo( $('#header') );
// */
	
	/// anonymous div for sound toggle
	$('<div style="background-color:#aaa; cursor:pointer; font-size:10px;padding: 4px;" />').text('HIDE/SHOW')
	.appendTo( $soundsdiv.find('#snd-btn') ).on("click", function(event){
		$sndtransdiv.toggle();
		$sndstatediv.toggle();
		$sndeventdiv.toggle();
	});
	
	$sndtransdiv.toggle();
	$sndstatediv.toggle();
	$sndeventdiv.toggle();
	
	
	//$mfollow = $('#mfollow');
	$mfollow = $('<div id="mfollow">Choose XXXX to become a part of WXYZ</div>');
	
	bgimgdiv = $('<div />').css({
		position: 'absolute',
		top: 0,
		left: 0,
		zIndex: 0
	});
	
	bgimg = $('<img />', {
		src:'res/bg.svg'	
	})
	
	bgimgdiv.append( bgimg );
	
	/// WHEN I LOADED IMAGE DURING FIRST TRANSITION IT CAUSED noticable glitch in animation.
	//$content.append( bgimgdiv );
	/// NOT THE ISSUE ... I think the next page is loading during the transition.
	
	$mfollow.hide();
	//console.debug(['mfollow',mfollow])
	
	if(ishome){
		initimgmap();
	}
	
}

function sndtoggle(){
	//debug('sndtoggle');
	sndflag = !sndflag;
	sndbtn.text( (sndflag)?'ON':'OFF' )
}

/*
SEQUENCE OF EVENTS {bad!? yes: transition shouldn't go until content is ready?}:

[ +START STATE CHANGE+ ] grabs elements out of page
	startlocchange()
called from event 'statechange' bound to 'window'

[ ONNAVCLICK:,opt2 ] plays sound !!! ONLY CALLED IF NAV BY LINK (not back/forward)
	onnavclick( $obj )
called from 'click' event bound to ajaxy link

[ PAGE LOADED:,carbon-in-atmosphere.html ]
	onpageload( opt )
called from 'success' of ajax

[ DO TRANSITION- opt2 ] begins animations
	dotransition()
	//NO: called by onnavclick($obj)
	called by onpageload()
	
[ CONTENT READY ] processes new content
	oncontentready()
called from 'success' of ajax AFTER html is replaced
*/

/// use these vars to grab the images out of the DOM so I can use them in the transition
// DON'T FORGET TO REMOVE THEM WHEN YOU GO TO SITEMAP
var lastimg1;
var lastimg2;
var atom1;
var atom2;

/// for transitions to/from home
var homeatom; // the big atom on the site-map
var homechar; // the selected character

/// called on window.statechange, which initiates the ajax call
/// detach the images and atoms for use in dotransition();
function startlocchange(){
//#-//	debug("STARTCHANGE "+ishome)
	//if( $lastcontent.length ){ $lastcontent.remove().empty(); }
	$lastcontent.empty(); 
	//console.debug(['lastcontent.empty',$lastcontent])
	
	lastimg1 = $content.find('#opt1-image');
	lastimg2 = $content.find('#opt2-image');
	
	/// are we starting from home
	if( lastimg1.length === 0 ){ // there's always at least one option, unless you're home
//#//		debug('s.change from Home!')
		//homeatom = $content.find('#home-carbon-img');
		//console.debug(['homeatom',homeatom])
		washome = true;
		//homeatom.detach();
		//$lastcontent.append( homeatom );
	} else {
		washome = false;
		//homeatom = null; //?
	}
	
	/* // hasn't been set
	if(goinghome){
		debug('s.change GOING Home!')
		return;
	}	*/
	
	if( lastimg1.length ){
		var off1 = lastimg1.offset();
		lastimg1.data("loc", { left: off1.left, top: off1.top }); /// store data for animation
		//debug("START img1 offset.T: "+ off1.top +" L:"+ off1.left)
		lastimg1.detach().css({
			'position':'absolute',
			'top': off1.top,
			'left': off1.left
		});
		//console.debug(['img1',lastimg1])
		//console.debug(['$lastcontent',$lastcontent])
		$lastcontent.append( lastimg1 );
	}
	if( lastimg2.length ){
		var off2 = lastimg2.offset();
		lastimg2.data("loc", { left: off2.left, top: off2.top }); /// store data for animation
		
		lastimg2.detach().css({
			'position':'absolute',
			'top': off2.top,
			'left': off2.left
		});
		$lastcontent.append( lastimg2 );
	}
	
	/// find and detach the atoms
	atom1 = $content.find('#atom1').find('img');
	atom2 = $content.find('#atom2').find('img');
	if( atom1.length ){
		var offa1 = atom1.offset();
		atom1.data("loc", { left: offa1.left, top: offa1.top }); /// store data for animation
		atom1.detach().css({
			'position':'absolute',
			'top': offa1.top,
			'left': offa1.left
		});
		//$lastcontent.append( atom1 ); /// moved to dotransition()
	}
	if( atom2.length ){
		var offa2 = atom2.offset();
		atom2.data("loc", { left: offa2.left, top: offa2.top }); /// store data for animation
		
		atom2.detach().css({
			'position':'absolute',
			'top': offa2.top,
			'left': offa2.left
		});
		//$lastcontent.append( atom2 );
	}	
}
			

var pulltext; /// poetic text for current state;
/// Texts that appear over images when you mouse over choices
var pulltext1;
var pulltext2;

var targOffset; /// used in transition for where state icon will be



/// called from ajaxify-html5.js when content has been updated. passes ref to content
function oncontentready( $con ){ /// I'm still passing #content as var $con, but not using it that way anymore
//#-//	debug("READY");
//	washome = ishome;
	///test for existence of carbon image that only exists in home page, aka, sitem-map.html
  ishome = ($content.find('#home-carbon-img').length)? true: false;
//#//	debug(['r.Home?', ishome, washome])
	
	if( ishome ){
		debug('### HOME SWEET HOME ###')
		$lastcontent.empty(); //??
		$nav.show()//$('#nav').show();
		$content.css({ minHeight: 0, height: 'auto'});//, clip: 'auto'
		
		
	} else {
		//$content.css({  }); 
		
		/*bgimg.height( $content.height() ).width( $content.width() )
		$content.append( bgimgdiv );*/
		
		//http://www.tutwow.com/htmlcss/quick-tip-css-100-height/
		//$content.css('opacity',0);
		$content.height( $(window).height() );
		$content.css({
			minHeight: '100%',/// seems to work for keeping #content at 100% of window height!!
			opacity:0/*,
			position:'absolute',
			top: 0,
			clip: "rect(0px,350px,350px,0px)"*/
		});	
		$nav.hide();
		//$('#nav').hide();
		/*if(washome){	
			 //docontentin();
		}*/
		
	}

	
	var youare = $content.find('#youare');
	var youaretxt = youare.find('#youare-txt');
	//var youareimg = youare.find('#youareimg');
	//console.debug(['youare',youare]);
	
	/// State Image
	var youicon = youare.find('#youare-img');
	/// MAP icon
	var youhere = youare.find('#youare-here');

	
	youare.css('cursor','pointer');
	/// dumb way to swap order!
	youare.detach();
	$content.append( youare );//	$content.prepend( youare );
	
	var ywide = youicon.width();
	youare.css( { position: 'absolute', bottom: 0, left: '50%' }) /// for relative centering
	youicon.css( { position: 'absolute', bottom: 0, left: ((-1 * ywide)/2) } )
	youhere.css( { position: 'absolute', bottom: 0, right: (ywide/2) } )
	
	var twide = 0.8*(($content.width() - ywide)/2) 
	youaretxt.css( { position: 'absolute', bottom: 0, left: (ywide/2), width: twide } )
	
	/// for transition /// NOT A GOOD PLACE TO SET!!	
	targOffset = youicon.find('img').offset();
	
	
	/// IF COMING FROM HOME DO THAT TRANSITION -------/////////
	if( washome ){	
		//$lastcontent.empty();
		$lastcontent.append( homeatom );
		$lastcontent.append( homechar );
		
		var ww = $content.width();
		var hh = $content.height();	
		//debug(['washome dims',ww,hh]);
		$lastcontent.css({
			//minHeight: '100%',/// seems to work for keeping #content at 100% of window height!!
			position:'absolute',
			top: 0,
			//clip: "rect(0px,400px,400px,0px)"
			clip: "rect(0px,"+ww+"px,"+hh+"px,0px)"
		});			

		homeatom.animate({ /// -70 for 1/2 height of atom
			left: ww/2 - 70, 
			top: hh/2 - 70 
		},2000)
		.animate({ opacity: 0 }, 500 )
		.queue(function() {
			$(this).remove();
		});			
	
		homechar.animate({
			left: -1*ww/2,   
			top: -1*hh,
			height: ww*2,
			width: ww*2
		},3000).animate({ 
			top: targOffset.top, 
			left: targOffset.left, 
			width: 200, 
			height: 200
		}, 2000 ).queue(function() {
			$(this).remove();
			docontentin();
		});
		// docontentin();
	}
	/// end TRANSITION -------/////////
	
/*	if(goinghome){
		$lastcontent.empty();
		debug('ready GOING Home!')
		/// move some of the css stuff above to below this return
		return;
	}	*/
	
	
/*
	youhere.css( { position: 'absolute', bottom: 0, left: ( -1 *(youhere.width() +  youicon.width()/2 ) )  } )

	youare.css( { position: 'absolute', bottom: 0 })
	youicon.css( { position: 'absolute', bottom: 0, left: (($content.width() - youicon.width())/2) } )

*/
	//console.debug(['youare offset', youare.offset(), youare.height()]);	
	//console.debug(['youare parent', youare.parent().attr('id'),  youare.parent().height()]);
	//console.debug(['youare prev', youare.prev().attr('id'),  youare.prev().offset(), youare.prev().height()]);

	var atoms = $content.find('#atoms');
	atoms.detach();
	atoms.css( { position: 'absolute', bottom: 0 })
	$content.append( atoms );	

//	youare.css({ position:'absolute', zIndex: 1000, bottom: 0})
//	youare.offset({ top: window.innerHeight, left: 0 })
	
	youare.hover(
		function (event) {
			youicon.css( { backgroundColor: '#ffffff' } ) // should use addClass
			playstatesnd();
			var offs = youicon.offset();
			//offs.top -= 100;
			//offs.left += 150;
			youare.append($mfollow);
			$mfollow.html(pulltext);
			$mfollow.show();
			//$mfollow.offset( { top: offs.top, left: offs.left });
			
			$mfollow.offset(function(index, coords) {
				//alert(index);
				//alert(coords.left);
				var tt = offs.top - $(this).height() - 20;
				var ll = offs.left - 200; // flush right; prevents txt overlapping
				return {left: ll, top:tt}; //<-- you need to return this.
			});					
			
			//console.debug(['mfollow',offs,$mfollow.offset(), $mfollow ])
			youaretxt.delay(500).fadeIn();
			youhere.delay(1000).fadeIn();
			
			/// RESTART STATE SOUND!!!
		}, 
		function (event) {
				youicon.css( { backgroundColor: '#CCCCCC' } ) // should use addClass

			//// DON'T NEED TO CALL HIDE WHEN DETACHING!!
				$mfollow.hide();
				$mfollow.detach();
				youaretxt.fadeOut();
				youhere.fadeOut();
		}
	);
		//debug("OVER IMAGE")
	//	youaretxt.stop(true,true).toggle('slow');
	//});
	youhere.hide();
	youaretxt.hide();
	//youaretxt.toggle();	
	
	pulltext = youaretxt.find('.poetic');
	pulltext.detach();
	
	youaretxt.find('.youare-opt').each(function(index) {
		//console.debug(index + ': ' + $(this).text());
		if(index){ // all but first element, for now
			var me = $(this);
			me.css( { height: '2em', width: 100, overflow: 'hidden', clear: 'both', opacity: 0.5 } ).hover(
					function () {
						me.stop(true,true).css( 'overflow','visible').animate({ height: '100%', width: '100%', opacity: 1 });	
					}, 
					function () {
						me.stop(true,true).css( 'overflow','hidden' ).animate({ height: '2em', width: 100, opacity: 0.5 });
					}
			);}
	});	
	
	
	$area1 = $content.find('#option1');
	$area2 = $content.find('#option2');
	
	
	$imgdiv1 = $content.find('#opt1-img-div');
	$imgdiv2 = $content.find('#opt2-img-div');
	
	$img1 = $imgdiv1.find('img');
	$img2 = $imgdiv2.find('img');
	
	//console.debug(['img1',$img1])
	
	/// these are the texts in the sidebars
	$txt1 = $content.find('#opt1-txt');
	$txt2 = $content.find('#opt2-txt');

	
	/// MAP icon
	//var youhere = youare.find('#youare-here');
	
	/*if( youhere.length ){
		var mapa = youhere.find('a');
		var mapi = youhere.find('img');
	
			
	}*/
	
	/// State Image
	//var youicon = youare.find('#youare-img');
	
	/*if( youicon.length ){
	*/
	
	///console.debug([ "$txt1, $txt2, $area1, $area2", $txt1, $txt2, $area1, $area2 ])
		
	if($txt1.length){
		// SWAP FOR POETIC!! //pulltext1 = $txt1.find('.ro-txt');
		pulltext1 = $txt1.find('.poetic');
		pulltext1.detach();
		//console.debug(['con text 1', pulltext1.html()])	
		
		$txt1.find('.txt-opt').each(function(index) {
    	//console.debug(index + ': ' + $(this).text());
			if(index){ // all but first element, for now
				var me = $(this);
				var hht = me.height();
				me.css( { height: '2em', width: 100, overflow: 'hidden', opacity: 0.5 } ).hover(
					function () {
						me.stop(true,true).animate({ height: hht, width: '100%', opacity: 1 });//.css( 'overflow','visible');	
						//me.stop(true,true).css( 'overflow','visible').animate({ height: '100%', width: '100%' });	
						//DOESN'T REALLY WORK. Height is hard to do without a stored value:
						//$(this).stop(true,true).animate({ width:'100%'}).animate({ height:'100%'}).css( 'overflow','visible');	
					}, 
					function () {
						me.stop(true,true).css( 'overflow','hidden' ).animate({ height: '2em', width: 100, opacity: 0.5 });
					}
				);}
		});
		
		/// wrapInner must be done on elements in the DOM, not detached
		$txt1.detach().prependTo($area1).addClass('sidebar-lt');//.wrapInner('<div class="fixbox" />')
		
		//console.debug([ "$txt1", $txt1, $txt1.html() ])
			
	/*	$txt1.detach();
		$txt1.addClass('sidebar-lt');
		$area1.prepend($txt1);*/
		
		$area1.mouseenter(function() {
			//$area1.append($mfollow); /// NEEDS TO BE INSIDE $img1
			$txt1.delay(500).slideDown(500);
		});
		$area1.mouseleave(function() {
			$txt1.slideUp(500);
			//$mfollow.detach();
		});	
		$txt1.hide();
	}
	
	if($txt2.length){
		pulltext2 = $txt2.find('.poetic');
		//pulltext2 = $txt2.find('.ro-txt');
		pulltext2.detach();
		
		$txt2.find('.txt-opt').each(function(index) {
    	//console.debug(index + ': ' + $(this).text());
			if(index){ // all but first element, for now
				var me = $(this);
				var hht = me.height();
				me.css( { height: '2em', width: 100, overflow: 'hidden', float: 'right', clear: 'both', opacity: 0.5 } ).hover(
					function () {
						me.stop(true,true).css( 'overflow','visible').animate({ height: hht, width: '100%', opacity: 1 });	
					}, 
					function () {
						me.stop(true,true).css( 'overflow','hidden' ).animate({ height: '2em', width: 100, opacity: 0.5 });
					}
				);}
	
		});
		
		/// wrapInner must be done on elements in the DOM, not detached
		$txt2.detach().prependTo($area2).addClass('sidebar-rt');//.wrapInner('<div class="fixbox" />')		
		
		
		$txt2.detach();
		$txt2.addClass('sidebar-rt')
		$area2.prepend($txt2);
	
		$area2.mouseenter(function() {
			//$area2.append($mfollow);
			$txt2.delay(500).slideDown(500)
			//$txt2.stop(true, true).slideDown(500)
		});
		$area2.mouseleave(function() {
			$txt2.slideUp(500)
			//$mfollow.detach();
		});	
		$txt2.hide();		
	}
	
	if($imgdiv1.length){
		
		$img1.css("position","absolute");
		
		var origh1 = $img1.height();//$img2.prop('height');//
		var origw1 = $img1.width();//.prop('height');//
		var targh1 = Math.round( origh1 * 1.1 );
		var targw1 = Math.round( origw1 * 1.1 );		

		var diff1 = Math.round((targh1 - origh1)/2);
		
		$imgdiv1.mouseenter(function(event) {
			$imgdiv1.append($mfollow);
			
			playeventsnd('.opt1'); /// this is a ridiculous way to choose which sound to play
			
			//alert('ENTER')
			//$img1.height( targh1 );
			//$img1.width( targw1 );
			//	debug("MOUSEENTER")
			$img1.animate({
				top: '-='+diff1,
				left: '-='+diff1,
				height: targh1,
				width: targw1
			},'fast');
			
			$mfollow.html(pulltext1);
			
			//move away from cursor to prevent mouseout on area div
			//$mfollow.css('top',event.pageY-120).css('left',event.pageX - 200);
			$mfollow.offset( { top: event.pageY  - 120, left: event.pageX - 160 });

			$mfollow.show();
					
			$imgdiv1.bind('mousemove', function(event) {
				//$mfollow.offset( { top: event.pageY  - 120, left: event.pageX - 300 });
				
				$mfollow.offset(function(index, coords) {
					//alert(index);
					//alert(coords.left);
					var tt = event.pageY - $(this).height() - 20;
					var ll = event.pageX - 100;
					return {left: ll, top:tt}; //<-- you need to return this.
				});				

				//	return false;
				//debug(event.pageX + ", " + event.pageY)
	
			});
			//alert('DE-ENTER')
		});
		$imgdiv1.mouseleave(function() {
			//$img1.height( origh1 );
			//$img1.width( origw1 );
			
			$img1.animate({
				top: '+='+diff1,//targoff.top,
				left: '+='+diff1,//targoff.left,
				height: origh1,
				width: origw1
			},'fast');
			
			$mfollow.detach();
						
			$mfollow.hide();
			$imgdiv1.unbind('mousemove');
		});
		/*$imgdiv1.on('click', function(){
			debug("ON IMG1 CLICK")	
		});*/
	}
	
	
	if($imgdiv2.length){
		$img2.css("position","absolute");

		
		/// offset: for placing mousefollower
		var offset = $area2.offset();
		offset.left += 40;
		offset.top +=120;
		
		var origh2 = $img2.height();//$img2.prop('height');//
		var origw2 = $img2.width();//.prop('height');//
		var targh2 = Math.round( origh2 * 1.1 );
		var targw2 = Math.round( origw2 * 1.1 );
    //p.html( "left: " + offset.left + ", top: " + offset.top );
		
		var diff2 = Math.round((targh2 - origh2)/2);
		
		$imgdiv2.mouseenter(function() {
			
			$imgdiv2.append($mfollow);
			
			playeventsnd('.opt2'); /// this is a ridiculous way to choose which sound to play
			
			//console.debug([origw2,'$img2.height',$img2.height( )])
			//$img2.height( targh2 );
			//$img2.width( targw2 );
			//debug("MOUSEENTER")
			$img2.animate({
				top: '-='+diff2,
				left: '-='+diff2,
				height: targh2,
				width: targw2
			},'fast');			
			
			//$mfollow.css('top',event.pageY-offset.top-120).css('left',event.pageX - offset.left -  80);
			
			$mfollow.html(pulltext2);
			
			$mfollow.show();
			$imgdiv2.bind('mousemove', function(event) {
				//$mfollow.offset( { top: event.pageY  - 120, left: event.pageX - 100 });
				$mfollow.offset(function(index, coords) {
					//alert(index);
					//alert(coords.left);
					var tt = event.pageY - $(this).height() - 20;
					var ll = event.pageX - 340;
					return {left: ll, top:tt}; //<-- you need to return this.
				});	
				//$mfollow.css('top',event.pageY-offset.top).css('left',event.pageX - offset.left - 80);
				//$mfollow.css('top',event.pageY-120).css('left',event.pageX - 40);
				//debug(event.pageX + ", " + event.pageY)
			})
		});
		$imgdiv2.mouseleave(function() {
			
			$mfollow.detach();

			//$img2.height( origh2 );
			//$img2.width( origw2 );
			$img2.animate({
				top: '+='+diff2,
				left: '+='+diff2,
				height: origh2,
				width: origw2
			},'fast');	
						
			$mfollow.hide();
			$imgdiv2.unbind('mousemove');
		});		
		/*$imgdiv1.on('click', function(){
			debug("ON IMG2 CLICK")	
		});*/
			
	}	
	
	if( ishome ){
		bgimgdiv.detach();
	} else {
		bgimg.height( $content.height() ).width( $content.width() )
		$content.prepend( bgimgdiv );
	}
}

/// do i even need to store these??
//var imgin;
//var imgout;


/// uses items removed from content in startlocchange()
function dotransition(){
//#-//	debug('TRANSITION ' + cclass)
	
	//// TARGET OFFSETS SHOULD BE ASSIGNED NOW!!!
	
	var imgin;
	var imgout;
	var atomin;
	var atomout;
	
	var ww = $content.width();
	var hh = $content.height();
	
	//debug(['dotrans dims',ww,hh]);
	
	var moveoff = 0;
	/// determine which image was clicked
	if( cclass == 'opt1' ){
		imgin = lastimg1;
		imgout = (lastimg2.length) ? lastimg2: null;
		moveoff = 100;
		atomin = atom1;
		atomout = (atom2.length) ? atom2: null;
	} else if( cclass == 'opt2' ){
		imgin = lastimg2;
		imgout = lastimg1;
		moveoff = -100;
		atomin = atom2;
		atomout = atom1;
	} else {
		/// EITHER GOING TO or COMING FROM home.
		/// cclass is undefined cuz the clicked link wasn't a transition option
//#//		debug('? tr.home ?')
		/*if( washome ){
			...
		}*/
	}
	/// animate selected image and atom
	//var ww = $(window).width();//$(document).width();
	//var hh = $(window).height();
	
	/*if(goinghome){
		debug('trans GOING Home!')
		return;
	}	*/
	
	$lastcontent.append( atom1 );
	if(atom2.length) $lastcontent.append( atom2 );
	
	$lastcontent.css({
		//minHeight: '100%',/// seems to work for keeping #content at 100% of window height!!
		position:'absolute',
		top: 0,
		//clip: "rect(0px,400px,400px,0px)"
		clip: "rect(0px,"+ww+"px,"+hh+"px,0px)"
	});		
	
	//debug("TARGET hh: "+ hh +" ww:"+ ww)
	if( imgin ){
	
		imgin.css('zIndex', '1000');
		atomin.css('zIndex', '1010');
				
		imgin.animate({
			left: -1*ww/2,   
			top: -1*hh,
			height: ww*2,
			width: ww*2
		},5000)
		.delay(1000)
		.animate({ 
			top: targOffset.top, 
			left: targOffset.left, 
			width: 200, 
			height: 200
		}, 1000 )
		.queue(function() {
			$(this).remove();
			
			docontentin();
			//playstatesnd();
			//$content.animate({opacity:1},1000); /// SEND IN THE NEXT CHOICE!!! hope it's loaded!!!!!!
			
		});
		
		atomin.animate({
			left: ww/2,
			top: hh/2
			/*left: -ww + atomin.data("loc").left*2,    
			top: -ww + atomin.data("loc").top*2
			,
			height: ww*2,
			width: ww*2*/
		},4000)
		.animate({ opacity: 0 }, 1000 )
		.queue(function() {
			$(this).remove();
		});
		
	}
	
	/// animate other image (if it exists)
	if( imgout ){
		imgout.css('zIndex', '100');
		atomout.css('zIndex', '110');
		//var off = imgin.offset();
		imgout.animate({
			//opacity: 0,
			height: 200,
			width: 200,			
			left: '+='+ (moveoff + 100),
			top: '+=100' /// needed cuz scaling
		},3000).animate({
			opacity: 0
		},500).queue(function() {
			$(this).remove();
		});
		
		atomout.animate({
		//	opacity: 0,
			height: 4,
			width: 4,
			left: imgout.data("loc").left + 200 + moveoff, /// need to add 100 cuz position is top-left corner
			top: imgout.data("loc").top + 200
			//top: hh/2
		},3000).animate({
			opacity: 0
		},500).queue(function() {
			$(this).remove();
		});		
		
	}	
}

function docontentin(){
	playstatesnd();
	
	var atoms = $content.find('#atoms');
	var youcan = $content.find('#youcan');
	
	atoms.css('opacity',0);
	youcan.css('opacity',0);
	$content.css('opacity',1);
	
	atoms.animate({opacity:1},1000); 
	youcan.delay(500).animate({opacity:1},1000); 

	//$content.animate({opacity:1},1000); 
}

/* an ajaxified link is clicked; called from ajaxify-html5.js  */
function onnavclick( $obj ){
	//debug('onnavclick');
	//var 
	cclass = $obj.attr('class');
//#-//	debug(['CLICK:', cclass]);
	
	//console.debug(['ONNAVCLICK:', $body.find($obj).html()]);
	//console.debug(['ONNAVCLICK:', $obj.html()]); // empty??
	//console.debug(['ONNAVCLICK:', $lastcontent.find('#'+cclass+'-image')]);
	
	/// Nav without option transition
	if( !cclass ){
		if( washome ){
			/// find the image that was clicked
			//var homec = $obj.find('img'); /// broken with image map
			
			/// Klumsy, but it works
			var homec = $nav.find('li[id='+ $obj.prop("id") +']').find('img');
			var hcoff = homec.offset();
			
			homechar = homec.clone();
			homechar.css({
				position: 'absolute',
				top: hcoff.top,
				left: hcoff.left,
				zIndex: 10
			});
			
			var homea = $content.find('#home-carbon-img');//$obj.find('img');
			var haoff = homea.offset();
			
			homeatom = homea.clone();
			homeatom.css({
				position: 'absolute',
				top: haoff.top,
				left: haoff.left,
				zIndex: 100
			});			
			
			//homechar.detach();
//#//			debug("cl. WAS home")
			//console.debug(['clicked image',homechar])
			
			goinghome = false;
		} else {
			homechar = null; //?
			homeatom = null; //?
			
//#//			debug("cl. GOING home")
			goinghome = true;
		}
	} else {
	}
	/// allow only one sound to play at a time
	/* if(cplaying) cplaying.pause(); */
	
	/// KLUDGY TEST!!! preventing site-map links from breaking
	if( $sndsnow ){
		//debug(['LINK sndsnow.length:', $sndsnow.length ]);
		//var cclass = $obj.attr('class');
	
		/// audio tag has same class as anchor that was clicked.
		var c = $sndsnow.find( "."+cclass );
		//debug(['-- snd:', c.length]);
		if( c.length ){
			cplaying = c[0];
			
		/// will this try/catch prevent IE 8 from breaking?
		//try {
			if( sndflag ) cplaying.play();
		//}
		//catch ( Exception ) { }
			
		} else {
		//	debug("NO SOUNDS")
			//debug("c home?")
		}
	}
	//dotransition();
}

/* an ajaxified page load has completed; called from ajaxify-html5.js */
function onpageload( opt ){
//#-//	debug(['LOADED']);
	//debug(['LOADED:', opt])
	curl = opt;
	dotransition();
}


///////////////// SOUND METHODS

/* ajaxify-html5.js passes a collection of objects culled/detached from loaded page */
function setsounds( $obj ){
	//console.debug( $obj.html() );
	if( $sndslast ){
	//	 debug( "$sndslast Exists")
		
		//var ls = $sndtransdiv.find( $sndslast );
		
		//console.debug( ls )
		$sndslast.remove();
		$sndslast = null;
	} else {
	//	 debug( "$sndslast DOES NOT EXIST")
	}
	$sndslast = $sndsnow;
	$sndsnow = $obj;
	
	$sndsnow.each(function(){
		//console.debug(["SND", $($(this).find('source')).attr('src')  ]);
		var src = $($(this).find('source')).attr('src');
		//console.debug(["SND", $(this).find('source').prop('src')  ]);
		//debug(["SND", $(this).find('audio').attr('id') ]);
		//	debug(["SND", $(this).find('audio').attr('class'), curl ]);
		//console.debug( $(this).html() );				
		
		$(this).css("float","none").css("clear","both").prepend( src.substr( src.indexOf('/'))+" - ");	
	});	
	if( $sndslast ){
		$sndslast.each(function(){
			$(this).css("backgroundColor","#adadff");	
		});		
	}
	
	//$soundsdiv.prepend( $sndsnow );
	$sndtransdiv.append( $sndsnow );
}

function setstatesound( $obj){
	if( cstatesnd.length ){
		//var ls = $sndstatediv.find( $cstatesnd );		
		//console.debug( ls )
		cstatesnd.remove();
		cstatesnd = [];//null;

	}
	cstatesnd = $obj;
	//console.debug($obj);
	if( cstatesnd.length ){
		/// this is just for labelling
		var src = $(cstatesnd.find('source')).attr('src')
		cstatesnd.css("float","none").prepend( src.substr( src.indexOf('/'))+" - ");	
	} else {
	//	debug("NO STATE SOUND??")
	}	
	$sndstatediv.append( cstatesnd );
}

function playstatesnd(){
	if( cstatesnd.length && sndflag ){ cstatesnd.find('audio')[0].play(); }
}

var eventsnds;

function seteventsounds($obj){
	if( eventsnds ){
		//var ls = $sndeventdiv.find( eventsnds );		
		//console.debug( ls )
		eventsnds.remove();
		eventsnds = null;

	}
	eventsnds = $obj;
	//console.debug($obj);
	
	
	if( eventsnds.length ){
		eventsnds.css("float","none");//.prepend( curl );	
		
		/// this is just for labelling
		/*eventsnds.find('audio').each(function(){
		//console.debug(["SND", $($(this).find('source')).attr('src')  ]);
			var src = $($(this).find('source')).attr('src');
			//console.debug( $(this).html() );				
			
			//debug(["eSND", src ]);
			eventsnds.append( src.substr( src.indexOf('/'))+" - ");	
		});//	*/		
	} else {
		//debug("NO EVENT SOUND??")
	}		
	$sndeventdiv.append( eventsnds );
}

function playeventsnd( opt ){
	if( eventsnds ){
		//debug(['LINK sndsnow.length:', $sndsnow.length ]);
	
		/// audio tag has class that is passsed as a string.
		var c = eventsnds.find( opt );
		//debug(['-- snd:', c.length]);
		if( c.length ){
			
		/// will this try/catch prevent IE 8 from breaking?
		//try {
			if( sndflag ) c[0].play();
		//}
		//catch ( Exception ) { }
			
		} else {
			//debug("NO SOUNDS")
		}
	}
}

function initimgmap(){
	//debug("INIT MAP")
	if($('#map')) {
		var bubble = $('<div class="bubble">hi</div>');
		//bubble.hide();
		
			// Loop through each AREA in the imagemap
			$('#map area').each(function() {
				var thisobj = $(this);
				
				var targ = $nav.find( 'li[id='+ $(this).prop("id") +']' )
				//debug(targ);
				var timg = targ.find('img');
				var ttxt = targ.find('a').text();
				//debug([timg,ttxt]);
				
				timg.css("position","absolute");
				
				
				var origh = timg.height();//$img2.prop('height');//
				var origw = timg.width();//.prop('height');//
				var targh = Math.round( origh * 1.1 );
				var targw = Math.round( origw * 1.1 );	
				
				var diff = Math.round((targh - origh)/2);
				//debug(diff)
				//var origoff = timg.offset();
				
				//debug([origoff,timg.offset() ])
				
				//var targoff = { top: timg.offset().top-diff, left: timg.offset().left-diff }
				//debug([origoff,targoff])
		
				// Assigning an action to the mouseover event
				thisobj.mouseover(function(e) {
					
					targ.append(bubble);
					bubble.text("Become a part of "+ttxt);
					//bubble.offset( {top: timg.offset().top, left:  timg.offset().top/* - bubble.width()*/})
					//bubble.show();
	//				debug(bubble)
					
					//var country_id = $(this).attr('id').replace('area_', '');
					//debug([origoff,targoff])
					timg.animate({
						top: '-='+diff,//targoff.top,
						left: '-='+diff,//targoff.left,
						height: targh,
						width: targw
					},'fast');
					
					//debug( [$(this),this] );
					//debug( ['href', $(this).prop('href')] );

				});
				
				// Assigning an action to the mouseout event
				thisobj.mouseout(function(e) {
					bubble.detach();
					//var country_id = $(this).attr('id').replace('area_', '');
					//$('#'+country_id).hide();
					timg.animate({
						top: '+='+diff,//origoff.top,
						left: '+='+diff,//origoff.left,
						height: origh,
						width: origw
					},'fast');
					
				});
				
				/*// Assigning an action to the click event
				$(this).click(function(e) {
					//e.preventDefault();
					//var country_id = $(this).attr('id').replace('area_', '');
					//alert('You clicked ' + country_id);
				});*/
			
			});
		}

		/*if($('#map')) {
				// Loop through each AREA in the imagemap
				$('#map area').each(function() {
			
					// Assigning an action to the mouseover event
					$(this).mouseover(function(e) {
						var country_id = $(this).attr('id').replace('area_', '');
						$('#'+country_id).show();
					});
					
					// Assigning an action to the mouseout event
					$(this).mouseout(function(e) {
						var country_id = $(this).attr('id').replace('area_', '');
						$('#'+country_id).hide();
					});
					
					// Assigning an action to the click event
					$(this).click(function(e) {
						e.preventDefault();
						var country_id = $(this).attr('id').replace('area_', '');
						alert('You clicked ' + country_id);
					});
				
				});
			}*/
}


//var audio = new Audio();

$(document).ready(function(){
	//debug( "snd0.currentSrc: " +snd0.currentSrc );
	init();
});